\documentstyle[draftcopy,epsfig,rotating,longtable,12pt,here]{article}

\setlength{\textwidth}{170mm}
\setlength{\textheight}{240mm}
\setlength{\oddsidemargin}{1mm}
\setlength{\evensidemargin}{1mm}
\setlength{\marginparwidth}{1cm}
\voffset=-20mm
\hoffset=0mm
\setlength{\parindent}{0pt}

\makeatletter
\long\def\psboxit#1{%
\begingroup\setbox0\hbox{#1}%
\dimen0=\ht0 \advance\dimen0 by \dp0%
    % Write out the PS code to set the current path using HEIGHT,
    % WIDTH , DEPTH of box0.
    \hbox{%
    \special{ps:  /box{%                  Processes the path of a rectangle.
%                  Needs : x0 y0 x1 y1.
         newpath 2 copy moveto 3 copy pop exch lineto 4 copy pop pop
         lineto 4 copy exch pop exch pop lineto closepath } bind def
         gsave 0 setgray currentpoint translate
        0
        \number\dp0 \space 15800 div    % hand tuned for dvips
        \number\wd0 \space 15800 div    % hand tuned for dvips
        \number\ht0 \space -15800 div   % hand tuned for dvips
        box fill grestore gsave 1 setgray}%
       \copy0\special{ps: stroke grestore}%
}%HBOX
\endgroup
}%
\makeatother

%\newcommand{\percent}{\verb\ % \}
\newcommand{\prompt}{\verb+     +\psboxit{[plus1]} $\sim$\verb+ > +}
\newcommand{\tprompt}{\verb+    +\psboxit{[tcsh]} $\sim$\verb+ > +}
\newcommand{\zprompt}{\verb+    +\psboxit{[zsh]} $\sim$}
\newcommand{\return}{$\hookleftarrow$ }
\newcommand{\TAB}{{\it TAB}  }
\newcommand{\tcsh}{\verb+tcsh +}
\newcommand{\zsh}{\verb+zsh +}
\newcommand{\cursor}{\rule[-1mm]{2mm}{4mm} }
\newcommand{\ESC}{{\it ESC} }

\def\listfigurename{List of Examples}

\newcounter{ex}
%\newenvironment{Example}[1]{\begin{quote} \addtocounter{ex}{1}
%\underline{Example \arabic{ex}:} #1 \\ \\
% \addcontentsline{lof}{figure}{\protect\numberline{\arabic{ex}}{#1}}}{\end{quote}}


\newenvironment{Example}[1]{\addtocounter{ex}{1}
%\underline{\bf Example \arabic{ex}:} #1 \\ 
%\vspace{7mm}
\noindent
\addcontentsline{lof}{figure}{\protect\numberline{\arabic{ex}}{#1}}
\noindent 
\\}{}

\makeindex

\makeglossary


\begin{document}

\title{The HEPiX Login Scripts Project\\
\vspace{1cm}
Implementation at CERN\\
\vspace{1cm}
Version 1\\
\author{Arnaud Taddei \thanks{CERN - Arnaud.Taddei@cern.ch}}
     }

\maketitle

\raisebox{90mm}[0mm][0mm]{\makebox[15cm][r]{CN/DCI/174}}

\begin{abstract}
This document describes how the HEPiX scripts are implemented at CERN.
In order to provide a common user environment on UNIX Systems 
a set of scripts was designed first by the DESY UNIX Commitee (DUX).

These scripts are covering the interactive environment which includes
the shell environment and will include the graphical environment (X11)
in the future. The "startup scripts" (shell environment) 
provide a way for users to login, work in interactive and batch mode
for the most common shells and platforms. 
\end{abstract}

%An updated and with CERN agreed version exists since march 1994.

%The other main part is a 
%proposal for a X11 configuration based on the X Display Manager (xdm).

%Furthermore we consider some configurations (e.g. key mappings) for 
%heavily used programs like the emacs editor.

\newpage
\tableofcontents
\listoftables
%\listoffigures



\newpage
%+=======Introduction==========================================================
\section{Introduction}

\subsection{Overview}

In front of the differences among UNIX platforms in the HEP community, 
it had been felt necessary to design a common user environment. 
Thus each UNIX user should be able to work on any platform in the HEP
community without having to reset his environment files.\\

In order to reach this not modest goal, 
the so called HEPiX login scripts project had been 
launched. 
This project started at DESY Zeuthen long ago (1993?). They produced 
the main engine and the main ideas. 
Then a joint project between DESY Zeuthen and CERN had been done
between February and end of March 1994. 
At least new work had been produced between DESY Hamburgh, DESY Zeuthen
and CERN.
For more information about this project you can refer to document 
168\footnote{refer documents as CN/DCI/168. This statement stands for all 
references accross this document}
from the UCO. This document was the report of the join project 
finished in April 94. But this document will progressively supersede the
old ones as far as the implementation and developpment goes on.\\


This project consists clearly in 2 phases which are:\\



1 - {\bf HEPiX 1}: provide a common user environment at shell level, \\

2 - {\bf HEPiX 2}: provide a common user environment at graphical level 
(i.e. XWindow). \\


Project phase 1 started with a set of files 
designed at DESY Zeuthen which had
been developped for bigger sites like CERN. Then the scripts had been put
in production at CERN, DESY and PISA between April
to June 1994 with the version 2.4 of the HEP scripts. They entered in 
the evolution maintenance phase. New requirements raised, bug fixes were 
implemented, small redesigns, etc.\\

Project phase 2 is under design and a first proposal had been published in 
document 168. DESY Hamburgh implemented a lot of things already which
are under implementation and developpment at CERN.\\

Of course, the target is the new users, new experiments, new machines but
it is opened to all the "old" users as well.\\

With this experience some feed back had been given from the services where 
the scripts were installed and a review had been started  with a new method
at CERN which ended with the new version of the HEP scripts plus 
their adaptation at CERN site level.\\

\subsection{Organisation of this document}

This document is meant for anybody including system adminitrators who want to 
install these scripts\footnote{in the state they are in the HEPiX 1 project}, 
people who want to understand what they are doing,
users who want to know what is set in this environment, people who are 
administering group of users and who like to know what they need more, etc. \\

Chapter \ref{c-design} is a collection of important design 
(and somehow more philosophical) topics about these scripts.\\

Chapter \ref{c-new-scheme} is a description of technical and implementation
aspects.\\

Chapter \ref{c-commands} to \ref{appl-config}
is a reference of all variables, commands, 
aliases, files, used or set by default and at what level in the HEPiX 
scripts.\\

Chapter \ref{c-conclusion} is the conclusion.\\

Appendices are giving even more details.\\

This document will be regularly updated according to the evolution of the
scripts especially concerning HEPiX 2.\\

%-=======Introduction==========================================================







\newpage
%+=======Design and Philosophical aspects======================================
\section{Design and Philosophical aspects} \label{c-design}

\subsection{General overview}

With the growing number of UNIX workstations from different vendors
the task of setting up a common user environment becomes more and more
difficult.  We felt a need to have a homogeneous environment from a
users' point of view in analogy to the HEPVM efforts on the IBM mainframe.
The aim of the project was to keep differences between the platforms
as small as possible.\\

The challenge is to ensure that all combinations of platforms and 
software products represent a reliable and consistent user environment. \\

%This work would not have be done without the work of Waltraud Nieprask 
%\footnote{DESY Zeuthen  - nieprask@ifh.de},
%Wolfgang Friebel
%\footnote{DESY Zeuthen  - friebel@ifh.de}, 
%Thomas Finnern 
%\footnote{DESY Hamburg - finnern@desy.de}
%and Karsten K\"unne \footnote{DESY Hamburg - kuenne@ifh.de}.

\subsubsection{The components}

To achieve this user environment attention must be paid to different
areas. \\


\underline{\bf Shells}  \\


The main access to the UNIX operating system operating system is given 
by the UNIX shell. Any improvement to it can result in considerably more
effective use of the system. \\

There are at least two major flavours, the Bourne shell and the C shell
flavour. \\

Initially the Bourne shell (sh) was developed which
provides nearly no comfort to the interactive user. A shell that is 
better than the Bourne shell for interactive use is the C shell but
the good control of input and output as in sh went away.
The shell script language was redesigned to
resemble  the C language. The tcsh as extension to  csh 
has many extra features like command line editing and completion
mechanisms. \\

David Korn from AT\&T developed the Korn shell (ksh)
and added also many features that made the C shell good for interactive work.
The Korn shell became part of System V and
even if it is on some systems it had one major problem: it isn't for free. \\

The Bash shell (Bourne again shell) from the GNU project is 
a free shell. Like the ksh, bash was 
based on the Bourne shell language and has many features from the C shell
and from other operating systems. \\

The zsh written by Paul Falstad is also a Bourne-like free shell and
like the tcsh has many additional features. \\ 

You can refer to document 162 ``Shell comparison'' from the CERN UCO to 
take advantage of a compilations of studies about the shell comparisons.\\

\underline{\bf Graphics environment} \\

The graphics environment is based on the X Window System, developed at
the Massachusetts Institue of Technology. There are now different
releases and versions of X : X11R4, X11R5 and the X11R6
(April 1994). X is based on the client/server model, in which the
application program (the client) does not directly access the display,
but communicates with an intermediary program (the server). The client
and server communicate using the X Protocol, which can run on top of
UNIX domain sockets, TCP/IP, or DECnet. As X designers chose to
articulate ``mechanisms not policy'', they didn't insist on a
particular ``look and feel'' like OSF/Motif and OPEN LOOK
specifications.\\

Let's be careful about the fact that the server in the X terminology
means a display server and not a server in the usual meaning. So one
particular client is the window manager that allows you to move,
resize, and iconify windows. But of course it has no responsibilities
about the existence of windows themselves which are ruled by the X
server and it can be local or remote.\\

There are different startup methods but from our point of view the X Display
Manager (xdm) is the best method for starting X sessions. \\
%This method will be discussed in section \ref{Graphics-environment}.\\

\underline{\bf Software products} \\

As the user needs tools to work, those tools need customization and
adaptations. There are interactions between software control files and
login scripts. Key bindings and key mappings are examples of control files
that should be set carefully and provided for groups of users.
So, editors, mail readers, news readers and browsers are examples of
classes of software where control files should be maintained and
supported for the average user. This list is not complete and can be
enlarged. 
%In the following some classical cases will be discussed (emacs, etc.)


\subsection{Few comments about combinatorics} \label{s-combinatorics}

The aim of this project is clearly not modest. 
If you simply consider the following attempt to measure the "combinatorics"
and the complexity $\chi$:\\

$\chi = M . G . W . S . K . Cxt . Tty . O$\\

Where:\\

{\small
\begin{longtable}{||p{15mm}|p{5cm}|p{5cm}||}
%\caption{Combinatorics elements}\\
\hline
{\bf Symbol} & {\bf Definition} & {\bf Value} \\
\hline
$M$       & Number of machines and UNIX platforms.
          & AIX, HP-UX, SunOS, Solaris 2, IRIX, ULTRIX, OSF/1, Convex, 
            (Linux ?).\\ 
\hline
$G$       & Number of graphical interfaces.
          & Plain Motif, Openwin and desktops like COSE and HP-VUE.\\
\hline
$W$       & Number of possible Window Managers.
          & {\tt mwm}, {\tt twm}, {\tt fvwm}, {\tt dtwm}, etc. \\
\hline
$S$       & Number of shells.
          & {\tt sh}, {\tt csh}, {\tt ksh}, {\tt bash}, {\tt tcsh}, 
            {\tt zsh}.\\
\hline
$K$       & Number of keyboard types.
          & PC-like, NCD-like, VT-like, HP-like, SunOS-like, etc.\\
\hline
$Cxt$     & Number of possible context of call.
          & {\tt telnet}, {\tt rlogin}, {\tt login}, {\tt su}, {\tt su -}, 
            etc.\\
\hline
$Tty$     & Number of possible terminal and pseudo-terminals.
          & {\tt VT100}, {\tt VT200}, {\tt xterm}, etc.\\
\hline
$O$       & Other factors like the impact of the network, etc.
          & \\
\hline
\end{longtable}
}

Thus, $\chi$ shows that you will deal with a big number of different 
\underline{behaviours}.\\

But, we need something, otherwise, it will take a great amount of time
for each user to set a proper and consistent environment.\\

\subsection{Main features of the phase 1}

The HEPiX scripts main features at shell level are:\\
{
\begin{longtable}{lp{17cm}}
- & enable powerful advanced shell features (command completion, history, 
  etc.),\\
- & set environment variables properly and consistently,\\
- & centralise the resources for developpment, support and maintenance,\\
- & allow different levels of customisation.\\
- & make the shells working in different supported environments: 
{\tt INTERACTIVE}, {\tt LOGIN}, {\tt BATCH}, {\tt X11}, etc.
\end{longtable}
}

They are "supporting" the following shells: \\
{
\begin{longtable}{lp{17cm}}
- & C-shell flavour: {\tt csh}, {\tt tcsh},\\
- & Bourne-shell flavour: {\tt sh}, {\tt ksh}, {\tt bash}, {\tt zsh}.\\
\end{longtable}
}
They are customised for each of the following platforms:\\
AIX, HP-UX, OSF/1, Solaris, IRIX, SunOS, ULTRIX, ConvexOS, Linux and
virtually any platform which follows the main UNIX streams can be adapted
easily.\\

They are working with distributed file systems (NFS, AFS, probably with DFS as
well).\\

\subsection{History about the HEPiX scripts project}

{%\small
\begin{longtable}{p{4cm}p{125mm}}
Until february 1994:   & all developments supported by DUX DESY Zeuthen.\\
 & \\
february - march 1994: & Axel Koehler (DESY Zeuthen) came to CERN to develop 
                         the HEPiX scripts project (CERN adaptation, 
                         documentation, AFS support, etc.).\\
 & \\
april - july 1994:     & Put the new HEPiX scripts in production on several 
                         services at CERN, DESY (both Hamburg and Zeuthen) and
                         PISA: get feed back.\\
 & \\
august - october 1994: & After the analysis of the feed back, we understood we 
                         had to change the method and to introduce a compiler
                         and a debugger.\\
\end{longtable}
}

From the scripts found on the common \verb+ftp.ifh.de:pub/hepix+ at Zeuthen,
we (at CERN):\\

{
\begin{longtable}{lp{17cm}}
- & instrument the code for the debugger,\\
- & pretify and improve the headers (version number, HEP and site contact,
  date of compilation, etc.),\\
- & put some small changes to fix some bugs and fulfill new requirements,\\
- & run the compiler to produce a set of "compiled" files per architecture in
  {\it inpro} (inproduction) and {\it debug} mode.\\
- & install the files on ASIS.\\ 
\end{longtable}
}


\subsection{Bug fixes and local modifications}

When we started the scripts into production, we had to fix the following 
 problems:\\


\underline{The {\tt whoami} bug:} \\
If \verb+~/bin/whoami+ redefines {\tt whoami}, the scripts break!\\
\underline{\it Solution}: compile the HEPiX scripts.\\

\underline{The checking of terminal connection in C-shells:}\\
You can't rely on the {\tt prompt} variable.\\
\underline{\it Solution}: test the {\tt status} of \verb+tty -s+; especially 
useful for {\tt NQS}.\\

\underline{The {\tt TERM} variable bug:}\\
When using the DESY {\tt xrlogin} where {\tt DISPLAY} is packed into 
the {\tt TERM} variable.\\
\underline{\it Solution}: don't forget to unpack the {\tt TERM} variable!\\

\underline{The asymmetric behaviour of the levels:}\\
Each file at HEP or site level should provide a hook for the other levels.\\
\underline{\it Solution}: check the hooks and provide all of them. Thi is only
possible because of a side effect of the compilation.\\

\underline{The values of the {\tt ENVIRONMENT} variable:}\\
Not always set properly, for example after an MIT {\tt xrsh}.\\
{\it Solution}:  reset the semantic of this variable.\\

\underline{The {\tt zsh} options:}\\
It had been felt that there are too many {\tt zsh} options set at the HEP
level.
\underline{\it Solution}: it had been solved while providing all 
interactive cusromisation file for {\tt zsh} at the site level. 
The {\tt zsh} options to be set had been discussed and is under 
discussion with users.\\


\subsection{Open questions} \label{open-questions}

During the introduction of the HEPiX scripts at CERN, a certain number of 
questions were raised:\\

Do we want {\tt root} to use the HEPiX scripts?\\

Do we want all users on a node to use the HEPiX scripts?\\

Do we want to set a lot of shell features? shouldn't we leave them?\\

Do we want only one level of adaptation? How many levels do we want, do we 
need?\\

\subsection{Differences between previous and new scheme}

\begin{tabular}{||p{4cm}|p{5cm}|p{7cm}||}
%\caption{Differences between previous and new versions of the Scripts}\\
\hline
{\bf Area} &
{\bf Before} &
{\bf Now} \\
\hline
{\bf Installation} &
Only 1 mode available: the scripts are enforced for any user even {\tt root}. &
2 modes of installation are available: 
1 - Let the user source the scripts,
2 - The scripts are enforced for almost any user.
Note: 1 and 2 are not mutually exclusive.\\
\hline
Delocalisation &
Not possible:
{\tt /etc} for the HEP level,
{\tt /etc/local} for system adaptations. &
Possible: recommended locations:
{\tt /usr/local/lib/hepix} for HEP and Site levels,
{\tt /etc/hepix} for system adaptations. \\
\hline
Levels &
HEP,
System,
User. &
HEP,
Site,
System,
Cluster,
Group,
User. \\
\hline
Who is using them &
Anybody including {\tt root} &
{\tt root} doesn't start anything,
{\tt uid} $<$ 100 doesn't start anything,
users in {\tt /etc/hepix/list-} don't start anything.\\
\hline
Compilation &
Not implemented &
Yes; improves security and robustness + a lot of good side effects (parse 
algo., bug fix, etc.).\\
\hline
Debugger &
Not implemented &
Implemented; gives the possiblity to systematise tests, gives a reference, and
really improves tracnig problems. ``Visualise'' the process.\\
\hline
\end{tabular}


%-=======Design and Philosophical aspects======================================





\newpage
%+=======New scheme============================================================
%\section{New scheme} 
\section{Shell environment} \label{c-new-scheme}

\subsection{Expectations from standardized scripts}
With the design of a shell environment for the user you have to consider 
different views. \\
\\
\underline{\bf User perspective} \\


The user wants a guaranteed functionality so that on all platforms the same 
feature works in the same way. Especially for inexperienced users a standardized
look and feel is very important. Having a set of variables that
describe the system the user can test these variables in his own
scripts and becomes independent from some system dependencies.\\ 
\\
\underline{\bf System administrator view} \\


He wants host-independent scripts which he  can install on all systems with a minimal
amount of modifications or configuration. The number of files to
maintain should be kept as small as possible.
In the scheme of standardized scripts the system administrator
must have the chance to make local adaptations corresponding to individual needs. \\


The shell environment comes into play in three different situations \\
\begin{itemize}
\item at login-time some scripts are run once at login or if you start a login shell 
\item interactive invocation for each new interactive shell. There you 
can configure some features of the shells that modify the interaction with users(eg. key bindings, completion 
mechanism)
\item non interactive invocation for each subshell. Here you should avoid tty related commands or commands requiring tty input
\end{itemize}


A proper user environment also has to be guaranteed after changing to different 
shells, in subshells,
after the su command and for the remote commands like rsh and in the batch 
environment. \\


The scripts should support all major shells used on Unix, the Bourne flavour
shells (ksh,bash and zsh) and C flavour shells (csh,tcsh). \\


In order to understand the layout of our proposed scripts it is necessary 
to understand which files are executed by default by a given shell (table  
\ref{standard-files}).\\


For csh and tcsh there are additional system dependencies. Also the names
of the scripts may differ not mentioned in the table. On some
UNIX systems in csh global initialisation files are executed while the
default action in tcsh on some systems is not to execute global
scripts (e.g. IRIX).

\bigskip

\begin{center}
\begin{table}[H]
{\bf \caption{Standard configuration files for the different shells}}
\label{standard-files}
\begin{tabular}{||l|l|l||}
\hline
{\bf Shell}     & {\bf Conditions}      & {\bf Executed scripts} \\
\hline
csh             & always                & \$HOME/.cshrc         \\
                & login                 & \$HOME/.login         \\
\hline
tcsh            & always                & /etc/csh.cshrc        \\
                & login                 & /etc/csh.login or \$HOME/.login \\
                & interactive           & \$HOME/.tcshrc or \$HOME/.cshrc \\
\hline          
ksh             & always                & ENV variable if set  \\
                & login                 & /etc/profile or \$HOME/.profile \\
                & interactive           & \$HOME/.kshrc         \\
\hline
zsh             & always                & /etc/zshenv           \\
                &                       & \$HOME/.zshenv        \\
                & login                 & /etc/zprofile         \\
                &                       & \$HOME/.zprofile      \\
                &                       & \$HOME/.zlogin        \\
                & interactive           & /etc/zshrc            \\
                &                       & \$HOME/.zshrc         \\
\hline
bash            & always                & not possible          \\
                & login                 & /etc/profile          \\
                &                       & \$HOME/.bash\_profile or \$HOME/.profile \\
                & interactive           & \$HOME/.bashrc        \\
                & non-interactive       & ENV variable if set   \\
\hline
\end{tabular}
\end{table}
\end{center}


%\subsection{HEP startup files}

\subsection{Description of dynamic behaviour}

In this section we describe some special features of the environment, login
and interactive parts of the scripts. 

\bigskip


\underline{\bf Environment which is always executed } \\


The following actions are performed

\begin{verbatim}
check for login permissions (/etc/nologin)
if (! HEP_ENV) {
    /* Basic shell environment */
    setting of path
    setting of environment variables (/usr/local/lib/hepix/sys.conf.[c]sh)
    setting of other environment variables (GROUP, ENV, ..)
    local adaptations (/usr/local/lib/hepix/env.[c]sh)
               } 
if (Prompt) {
    setting of prompt
    sourcing of the interactive parts
              - defining aliases
              - enable advanced features 
             }
\end{verbatim}

\medskip


If there exists a /etc/nologin file  the user cannot
login and he gets a message about the reason (standard mechanism 
on many systems).  \\
For improving the execution effiency an environment variable HEP\_ENV is defined. 
If this variable is set then the environment is assumed to be 
partly set and in 
subshells only the interactive part is executed again. \\


To manage a change of a shell to the ksh or bash the ENV variable is set to /etc/zshenv. \\


This environment part includes also the setting of the following environment
variables which the user can use in his own scripts: \\

\begin{itemize}
\item   {\bf USER}    is defined because some systems only set the variable LOGNAME 
\item   {\bf GROUP}   is set and can be used for a group support

\item   {\bf PATH} will be extended as  mentioned in \ref{Files}
\item {\bf HOST} is set to the hostname (without domainname)
\end{itemize}

\bigskip


\underline{\bf Login part }\\


The following actions are performed
\begin{verbatim}
source the environment file if it was not executed yet (for ksh,bash,csh)
set ENVIRONMENT variable
if ( ! BATCH ) {
  terminal type check and changing to a proper type (/usr/local/lib/hepix/termset.[c]sh)
  set terminal characteristics
  check the incoming folder for mail
  local login scripts /usr/local/lib/hepix/login.[c]sh
                }
\end{verbatim}


Because in most cases the csh, ksh and bash do not have any global configuration 
files which are always executed the actions described before are
performed in addition if necessary. \\

In order to avoid tty related commands or commands requiring tty input a 
check for batch mode takes place. In the Bourne-like shells you
are in interactive mode if a file descriptor is associated with a terminal device, in the C-like shells
you are in interactive mode if the prompt is set. Under some circumstances,
e.g. if you login via a terminal server then it is possible that you
get an improper terminal type (eg. dumb, network). An optional file 
/usr/local/lib/hepix/termset.[c]sh changes such 
types to a terminal type which is
described  in /usr/lib/terminfo or /etc/termcap. \\

Afterwards some settings of the terminal characteristics  will be made
(for instance defining the erase key dependent on the RUBOUT variable). \\ 


Other stty settings cover the interrupt key (Ctrl C) and the suspend key (Ctrl Z). \\
After the execution of the login file for local adaptations 
(/usr/local/lib/hepix/login.[c]sh) a check on incoming mail is done.

\bigskip


\underline{\bf Interactive part} \\


The last part is used for settings of the interactive environment. \\

The prompt acts as a reminder of where you logged into and shows your current
directory. Where possible the tilde notation for home directories is
used. 
In all cases the superuser is indicated by a
hash sign ("\#") in his prompt. \\

A small set of common aliases or functions is defined. You can use these 
aliases in all shells and systems in the same way.\\




\subsection{Installation and delocalisation} \label{s-installation}

%\underline{\bf Before}\\

%The HEP level was installed under \verb+/etc+ replacing all the vendor 
%supplied shell startup-files. 
%The local adaptations were put under \verb+/usr/local/lib/hepix+\\

%\underline{\bf Now}\\

The HEP level and the site level (CERN adaptation) are put under 
\verb+/usr/local/lib/hepix+. 
The system adaptation is put under \verb+/etc/hepix+.\\

\subsubsection{2 modes of installation}

Then, as system administrator, you have two modes of installation: \\

1 - you let the user source the scripts from 
    \verb+/usr/local/lib/hepix+ (refer to templates, central 
    templates and {\tt uco} in \ref{ref-aux} and in \ref{Files}),\\

2 - you enforce the scripts under \verb+/etc+ replacing the 
    vendor supplied shell startup-files by a set of wrappers files (refer
    to wrappers in \ref{ref-aux} and in \ref{Files}).\\

\begin{quote}
{\bf Note1:} Mode 1 and 2 are not mutually exclusive.\\
\end{quote}

\begin{quote}
{\bf Important system management note 2:}\\

 Mode 1 is intended for 
two reasons: it helps you, system administrator to test the hepix 
scripts and it provides you a way to help people on your system
to migrate smoothly to this new environment. You should provide 
and use the recommended templates and auxiliary files. The {\tt uco}
function might help you resetting your environment. See next section.\\

Mode 2 is intended for new services which have to provide an environment
for users.
\end{quote}

\subsubsection{Auxilliary files} \label{ref-aux}

\underline{\bf templates}\\

A set of templates files can be found under 
{\tt /usr/local/lib/hepix/templates}. These templates consist of 3 parts:\\

a header which provides contact names, description, etc., \\
a call to a file \verb+/usr/local/lib/hepix/central_*.[c]sh+ where 
\verb+*+ could be \verb+env+ or \verb+login+.\\
a body full of comments to help you setting your environment.

The document 170, 171, 172 and 175 are short documents which explain some
issues with the setting of the \verb+PATH+ (document 170), the setting
of options for {\tt zsh} (document 175), where you can run commands which 
produce an output on the terminal (document 171 for {\tt zsh} and 172 for
{\tt tcsh}).\\

The following table provides the names of the configuration files you can
use according to your shell:\\

\begin{center}
\begin{table}[H]
{\bf \caption{Standard users dot-files.}}
\begin{tabular}{||l|l|l||}
\hline
{\bf Shell}     & {\bf Conditions}      & {\bf Executed dot files} \\
\hline
csh             &always                 &.cshrc \\
                &login                  &.login \\
\hline
tcsh            &always                 &.tcshrc or \\
                &                       &.cshrc \\
                &login                  &.login \\
\hline
ksh             &login                  &.profile \\
                &interactive            &.kshrc \\
\hline
zsh             &always                 &.zshenv             \\
                &login                  &.zprofile and .zlogin \\
                &interactive            &.zshrc \\
\hline
bash            &login                  &.bash\_profile or \\
                &                       &.profile \\
\hline
\end{tabular}
\end{table}
\end{center}


\underline{\bf {\tt uco} command}\\

The \verb+uco+ command stands for User COmpagnon or User Consulting Office.\\
It could help you resetting your dot files.\\

For example if you want to reset your user dot files according to the 
{\tt tcsh} shell, you can simply run:\\

\verb+    > uco -p tcsh+\\

It does the following actions:\\

It copies your dot files in your \verb+$HOME+ directory and adds the extension
\verb+.number+ where \verb+number+ is the greatest number already found
$+ 1$.\\

It looks in the Group Level templates directory if there are any files.
For example at CERN for group c3 on the AFS cell, it will look in:
\verb+/afs/cern.ch/group/c3/templates+ if it finds files like \verb+tcshrc+, 
\verb+login+, etc.\\

If it finds nothing at group level it looks in the standard place
\verb+/usr/local/lib/hepix/templates+.\\

Then it copies the files it found in your \verb+$HOME+ directory.\\

This command does more things and can reset your mail configurations
files, news configuration files, X Windows configuration files in the near
future.\\ 

You should anyway consult the man pages for this command:\\

\verb+    > man uco+\\


\underline{\bf central-templates}\\

Files used in mode 1 (see \ref{s-installation}) to call 
the HEP scripts and to make sure that the latter haven't been used 
already (see protection variables in \ref{s-shell-variables-HEP}).\\

These files are the one directly called by the templates.\\

There are 4 files: \\

{\tt central\_env.csh}, 
{\tt central\_login.csh}, {\tt central\_env.sh}, {\tt central\_login.sh}.\\

They are located in \verb+/usr/local/lib/hepix+ and they are called by the
templates (refer \ref{s-templates}).\\


\underline{\bf wrappers}\\

Files used in mode 2 (see \ref{s-installation}) to call 
the HEP scripts and to make sure that 
{\tt root} and other users don't use the HEP scripts.\\

The wrappers are a set of 10 files which are replacing the vendor supplied
shell startup-files under \verb+/etc+. You can read them into the 
repository \verb+/usr/local/lib/hepix/wrappers+\\

\begin{center}
\begin{table}[H]
{\bf \caption{Wrappers provided with the HEPiX scripts.}}
\begin{tabular}{||l|l|l||}
\hline
{\bf Conditions}     & {\bf Bourne shell flavor} & {\bf C shell flavor} \\
\hline
always               & /etc/zshenv               & /etc/cshrc \\
\hline
login                & /etc/zprofile             & /etc/csh.login \\
                     & /etc/profile              &                \\
\hline
interactive          & ksh: /etc/kshrc           & csh: /etc/csh.cshrc \\
                     & bash:/etc/bashrc          & tcsh:/etc/tcshrc \\
                     & zsh: /etc/zshrc           &                 \\
\hline
\end{tabular}
\end{table}
\end{center}

Consult as well section \ref{Files}.




\subsection{levels}

The following levels are supported:\\

%CERN adaptation supports the following levels:\\
\begin{quote}
1 - HEP level,\\
2 - Site level (here it is CERN),\\
3 - System level,\\
4 - Cluster level,\\
5 - Group level,\\
6 - User level.\\
\end{quote}

\subsubsection{"Mechanical" aspects}

%\begin{figure}
%\begin{turn}{90}
\begin{sideways}
\begin{sideways}
\begin{sideways}
\epsfig{file=levels.eps}\\
\end{sideways}
\end{sideways}
\end{sideways}
%\end{turn}
%\end{figure}

If you installed the HEPiX scripts in mode 1 (see \ref{s-installation}),
then when the shell reads the user dot files which should be the templates,
it will source the central-files. The central-files will detect that the
HEPiX scripts haven't been installed in enforced mode (mode 2) and they will
start to execute all the levels beginning with the HEP level. If there are
files at any level they will be sourced.   \\

If you installed the HEPiX scripts in mode 2 (see \ref{s-installation}),
the shell (the good ones!!) start reading the wrappers which test 
if you are allowed to go further. If yes, the shell will start the
HEPiX scripts levels from the HEP level up to the end. Then the shell
executes the user dot files and the user dot files will start sourcing
the central-templates files. The latter will recognise that the HEPiX scripts
have been executed already so they won't ``loop'' and the shell will
execute the end of the user dot files.\\

\begin{quote}
Note: No level is mutually exclusive. The numbers show in what order
are called the levels. A level with a number $n$ can redefine anything
which had been set had level $n - 1$. So the user can redefine everything.
\end{quote}

\newpage
\subsubsection{"Conceptual" aspects}

\begin{sideways}
{\small
\begin{tabular}{||p{3cm}|p{6cm}|p{6cm}|p{6cm}|}
%\caption{Conceptual levels}\\
\hline
{\bf Conceptual levels}  & {\bf Description} & {\bf Location} &
{\bf Responsability}\\
\hline
{\bf HEP level}          & The main "Engine"; calls the files at the other
                           levels in the right order; gives basic settings.
                         & {\tt /usr/local/lib/hepix}
                         & HEPiX Developpers.\\
\hline
{\bf Site level}         & The Site adaptation (for instance CERN, DESY, etc.)
                           Specifies environment variables to fit CERN's 
                           default model (AFS, etc.); provides hooks for other
                           levels.
                         & {\tt /usr/local/lib/hepix}
                         & Site responsibles or system administrators.\\
\hline
{\bf System level}       & {\bf Optional} - Provides a place for system 
                           specificities; Can provide a value for {\tt CLUSTER}
                           and {\tt CLUSTER\_DIR} variables to enable the
                           Cluster level.
                         & {\tt /etc/hepix}
                         & System administrator.\\
\hline
{\bf Cluster level}      & {\bf Optional} - Provides a place for cluster of 
                           machines specificities.
                         & \verb+$CLUSTER_DIR+ default is 
                           \verb+/etc/hepix/cluster+
                         & System administrator.\\
\hline
{\bf Group level}        & {\bf Optional} - Provides a place for group of 
                           users specificities.
                         & \verb+$GROUP_DIR+ default is 
                           \verb+/afs/cern.ch/group/$GROUP+
                           & Group administrators or responisbles.\\
\hline
{\bf User level}         & Usual user dot files.
                         & \verb+$HOME+
                         & User.\\
\hline
\end{tabular}
}
\end{sideways}

According to who you are you have the responsibility to maintain your
environment at your level. For instance, if you are administering
one machine you have the responsibility of the system level and you 
can ``play'' with any file in \verb+/etc/hepix+.\\

\begin{quote}
{\bf Note:} that the Cluster level looks like ``syntaxic suggar''.\\
\end{quote}

\subsubsection{List of files in each level} \label{all-files-tables}


\input{files.tex}

\newpage
\subsection{Who is using the HEPiX scripts?}

%\underline{\bf Before}\\

%Any user included {\tt root}, {\tt adm}, 
%etc.\\


%\underline{\bf Now}\\

It had been decided that (see \ref{open-questions}):\\

{\tt root} never uses the HEP scripts,\\
all users with {\tt uid} less than 100\footnote{At CERN, the following 
convention stands: all users with a {\tt uid} less than 100 are not considered
as real users.} don't use the HEP scripts, \\
all users who have their {\tt username} in 
{\tt /etc/hepix/list-} don't use the HEP scripts.\\

\subsection{Compilation}

With the new versions (above 2.4.1) the scripts are {\it compiled} which
means that each occurence of any UNIX command is replaced by the command
name plus the full absolute path.\\

%Organisation with one source repository. \\

This is needed to prevent the following bug. Assume a user redefined
the '{\tt whoami}' command and put it under \verb+$HOME/bin+. If
in the file \verb+sys.conf.*+ you set {\tt USERPATH} to be
'\verb+$HOME/bin /usr/bin ...+' .
As \verb+$HOME/bin+ is before any other system directory in the {\tt USERPATH}
variable then in the {\tt PATH} variable, the scripts will call the user
'\verb+whoami+' command instead of the system one and they will probably 
break.\\

Another feature of the compilation step is that the parsing algorithm
which was evaluating the environment variables you provided in the 
\verb+sys.conf.$OS+ file is replaced by a simple {\it source} of a file
\verb+sys.conf.csh+ or \verb+sys.conf.sh+ depending on the shell flavour
of the shell (csh $=$ C-shell; sh $=$ Bourne-shell)\footnote{refer to 162, 163
for more informations}. 
The latter files are the output of the compilation procedure and are the source
of these two files is the previous \verb+sys.conf.$OS+.
It increases the performances and the flexibility.\\

The compiler pretifies the code at the HEP level and can produce the code
in {\it inproduction} (or simpler {\it inpro}) mode or in {\it debug} mode
automatically from the same source files.\\

Summary about compiler's features:\\

{\small
\begin{longtable}{lp{16cm}}
- & this is a perl program.\\
- & replaces any occurence of a UNIX command found in the HEPiX scripts
    at any level and replaces it by its name $+$ its absoulte path.\\
- & builds a {\tt sys.conf.csh} and {\tt sys.conf.sh} file from a 
  \verb+sys.conf.$OS+ file.\\
- & changes the parse algorithm by a simple source of \verb+sys.con.[c]sh+.\\
- & replaces some variables by their values (Meta variables).\\
- & if in {\it inpro} mode, removes the lines which instrument the code.\\
- & run the {\it make} phase in order to get the {\it inpro} mode.\\
- & prettifies the output (almost).\\
\end{longtable}
}




\subsection{Debug mode}

The section \ref{s-combinatorics} shows the complexity of the problem.
So a {\it debug} mode is needed to get a reference, to visualise the 
path through all the files, to trace a problem.\\

All the code is instrumented and at compile time, you can produce a debug mode
of the scripts. Then you can install the scripts in debug mode onto one 
machine.\\

This debug mode simply dumps some information into the file 
\verb+/tmp/hepix-log.$$+ where of course \verb+$$+ is the process id of 
the shell which had been started\footnote{At CERN it is installed in debug mode
onto the service {\tt cnwgs1} without any problem for users}.\\

The informations dumped are what file is opened, what file is closed,
what is the value of this or that variable, etc.\\

Moreover, this output file can be processed by a {\tt debug-analyser.pl} 
command which gives a graphical output of what files have been called in
what order.\\
%(refer \ref{s-debug}). \\

\verb+    > cat /tmp/hepix-log.$$ | debug-analyser.pl > analyse+\\
\verb+    > gnuplot analyse+\\

It produces a file \verb+analyse.ps+ which you can print.\\

Summary of the {\it debug} mode:\\

{\small
\begin{longtable}{lp{15cm}}
- & when you run a shell, it dumps informations into \verb+/tmp/hepix-log.$$+
    (where, of course \verb+$$+ is the {\tt PID} of the shell you run.).\\
- & transparent for the user.\\
- & provides a reference to debug a problem.\\
- & visualise the files which are openned with a \verb+debug-analyser.pl+
    command which can process a \verb+/tmp/hepix-log.$$+ file.\\
\end{longtable}
}


Probably need to get automatic regressif tests (sh, telnet , xrsh, etc.)
expect could be useful.\\


\input{zsh.tex}\\

\underline{How to read this figure:}\\

The X axis represents time and the Y axis represents the files. Thus you
read this figure in the following way.\\

At time 0 on the X axis, there is
a mark in front of \verb+/etc/zshenv+ file which means that when \verb+zsh+
started it opened the file \verb+/etc/zshenv+. \\

At time 1 there is a mark in
front of the file \verb+HEP_zshenv+ which means that
that file is sourced from \verb+/etc/zshenv+ and it had been oppened at time
1. \\

At time 2, the file \verb+sys.conf.sh+ had been 
opened and sourced from \verb+HEP_zshenv+. \\

Then at the
next step there is another mark in front of the same file 
\verb+sys.conf.sh+ which means that this file had been
closed. 

At step 4 the shell opens the file  
\verb+env.sh+ which is sourced from 
\verb+HEP_zshenv+
and then it is closed at step 5. the file 
\verb+HEP_zshenv+ is then closed at step 6 and 
\verb+/etc/zshenv+ is closed at step 7. \\

Then the environment part at
system level is finished. \\

The shell is going to read the first user file
\verb+~/.zshenv+ which is opened at step 8. This file sources the
\verb+central_env.sh+ which is openned at step 9
and closed at step 10. \\

Then the file \verb+~/.zshenv+ is closed at step 11.
At this time the environment for the user is set. \\

Between steps 12 to 21 the shell part will be set and from step 32 to 36
the login part is achieved.\\


%-=======New scheme============================================================





\end{document}